# spring-boot-demo Project TODO List

## Module plan (completed: 54 / 66)

- [x] ~~demo-helloworld(helloworld example)~~
- [x] ~~demo-properties (read configuration file information)~~
- [x] ~~demo-actuator (endpoint monitoring for Spring boot)~~
- [x] ~~demo-admin-client (for Spring boot visual control client)~~
- [x] ~~demo-admin-server (for Spring boot visual control server)~~
- [x] ~~demo-logback (integrated logback log)~~
- [x] ~~demo-log-aop (use AOP to intercept request log information)~~
- [x] ~~demo-exception-handler (unified exception handling)~~
- [x] ~~demo-template-freemarker (using template engine - Freemarker)~~
- [x] ~~demo-template-thymeleaf (using template engine - thymeleaf)~~
- [x] ~~demo-template-beetl (using template engine - beetl)~~
- [x] ~~demo-template-enjoy (using template engine - JFinal-Enjoy)~~
- [x] ~~demo-upload (upload - integrated local upload and seven cattle cloud upload)~~
- [x] ~~demo-orm-jdbctemplate (operating SQL relational database - JdbcTemplate)~~
- [x] ~~demo-orm-jpa (operating SQL Relational Database - JPA)~~
- [x] ~~demo-orm-mybatis (operating SQL relational database - mybatis)~~
- [x] ~~demo-orm-mybatis-mapper-page (operating SQL relational database - integrating mybatis generic Mapper, PageHelper)~~
- [x] ~~demo-orm-mybatis-plus (operating SQL relational database - integrating mybatis-plus, Mapper, ActiveRecord)~~
- [x] ~~demo-orm-beetlsql (operating SQL relational database - beetlSQL)~~
- [x] ~~demo-cache-redis (using redis for caching)~~
- [x] ~~demo-cache-ehcache (using Ehcache for caching)~~
- [x] ~~demo-email (integrated mail service)~~
- [x] ~~demo-task (scheduled task - Task implementation)~~
- [x] ~~demo-task-quartz (scheduled task - Quartz implementation)~~
- [x] ~~demo-task-xxl-job (scheduled task - XXL-JOB for Distributed Scheduling)~~
- [x] ~~demo-swagger (integrated Swagger for API interface test management)~~
- [x] ~~demo-swagger-beauty (integrated custom and more beautiful Swagger test management of API interface)~~
- [x] ~~demo-rbac-security (implementing RBAC-based permission model - Spring Security)~~
- [ ] demo-rbac-shiro (implementing RBAC-based permission model - shiro)
- [x] ~~demo-session(unified Session Management)~~
- [ ] demo-oauth (OAuth2 certification)
- [x] ~~demo-social (integrated JustAuth implements third-party authorization verification, and implements third-party logins such as QQ, WeChat, GitHub, Google, Xiaomi, etc.)~~
- [x] ~~demo-zookeeper (use zookeeper to implement distributed locks with AOP)~~
- [x] ~~demo-mq-rabbitmq (integrated messaging middleware - RabbitMQ)~~
- [ ] demo-mq-rocketmq (integrated messaging middleware - RocketMQ)
- [x] ~~demo-mq-kafka (integrated message middleware - Kafka)~~
- [x] ~~demo-websocket (integrated websocket service)~~
- [x] ~~demo-websocket-socketio (integrated socketio implements websocket service)~~
- [ ] demo-ureport2 (integrated ureport2 implements a custom complex Chinese-style reporting engine)
- [ ] demo-uflo (integrated uflo implementation process control engine)
- [ ] demo-urule (integrated urule implementation rules engine)
- [ ] demo-activiti (integrated of Activiti to implement process control engine)
- [x] ~~demo-async (Spring boot implements asynchronous calls)~~
- [x] ~~demo-dubbo (integrated dubbo)~~
- [x] ~~demo-war (packaged into a war package)~~
- [x] ~~demo-elasticsearch (integrated ElasticSearch)~~
- [x] ~~demo-mongodb (integrated MongoDb)~~
- [x] ~~demo-neo4j (integrated neo4j graph database)~~
- [x] ~~demo-docker (packaged into docker image)~~
- [x] ~~demo-multi-datasource-jpa (integrated JPA multi data source)~~
- [x] ~~demo-multi-datasource-mybatis (integrated with mybatis multi-data source)~~
- [x] ~~demo-sharding-jdbc (integrated sharding-jdbc implementation sub-library table)~~
- [ ] demo-tio (integrated t-io)
- [ ] demo-grpc (integrated grpc, configure tls/ssl) see [ISSUE#5](https://github.com/xkcoding/spring-boot-demo/issues/5)
- [x] ~~demo-codegen (integrated velocity auto-generated code)~~
- [x] ~~demo-graylog (integrated gralog log management)~~
- [ ] demo-sso (integrated single sign on) see [ISSUE#12](https://github.com/xkcoding/spring-boot-demo/issues/12)
- [x] ~~demo-ldap （integrated ldap）see [ISSUE#23](https://github.com/xkcoding/spring-boot-demo/issues/23)~~
- [x] ~~demo-dynamic-datasource（add datasource dynamically, switch datasource dynamically）~~
- [x] ~~demo-ratelimit-guava（use Guava RateLimiter to protect API by standalone rate limiting）~~
- [x] ~~demo-ratelimit-redis（use Redis and Lua script implementation to protect API by distributed rate limiting）~~
- [x] ~~demo-https（integrated HTTPS）~~
- [x] ~~demo-elasticsearch-rest-high-level-client（integrated Elasticsearch 7.x version，use official Rest High Level Client to operate ES data）~~
- [ ] demo-springbatch（data process）
- [ ] demo-security-justauth（use JustAuth to login GitHub，and use Spring-Security to manage login state）
- [x] ~~demo-flyway（integrated Flyway to initialize tables and data in database, Flyway also support the sql script version control）~~

## Remarks

Try to ensure that the corresponding demos are integrated in the order above.

